Index: uspace/lib/gui/label.c
===================================================================
--- uspace/lib/gui/label.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
+++ uspace/lib/gui/label.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -0,0 +1,194 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup gui
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <str.h>
+#include <malloc.h>
+
+#include <drawctx.h>
+#include <surface.h>
+
+#include "window.h"
+#include "label.h"
+
+static void paint_internal(widget_t *w)
+{
+	label_t *lbl = (label_t *) w;
+
+	surface_t *surface = window_claim(lbl->widget.window);
+	if (!surface) {
+		window_yield(lbl->widget.window);
+	}
+
+	drawctx_t drawctx;
+
+	drawctx_init(&drawctx, surface);
+	drawctx_set_source(&drawctx, &lbl->background);
+	drawctx_transfer(&drawctx, w->hpos, w->vpos, w->width, w->height);
+
+	sysarg_t cpt_width;
+	sysarg_t cpt_height;
+	font_get_box(&lbl->font, lbl->caption, &cpt_width, &cpt_height);
+	if (w->width >= cpt_width && w->height >= cpt_height) {
+		drawctx_set_source(&drawctx, &lbl->foreground);
+		drawctx_set_font(&drawctx, &lbl->font);
+		sysarg_t x = ((w->width - cpt_width) / 2) + w->hpos;
+		sysarg_t y = ((w->height - cpt_height) / 2) + w->vpos;
+		if (lbl->caption) {
+			drawctx_print(&drawctx, lbl->caption, x, y);
+		}
+	}
+
+	window_yield(lbl->widget.window);
+}
+
+static void on_rewrite(widget_t *widget, void *data)
+{
+	if (data != NULL) {
+		label_t *lbl = (label_t *) widget;
+		const char *new_caption = (const char *) data;
+		lbl->caption = str_dup(new_caption);
+
+		sysarg_t cpt_width;
+		sysarg_t cpt_height;
+		font_get_box(&lbl->font, lbl->caption, &cpt_width, &cpt_height);
+		lbl->widget.width_min = cpt_width + 4;
+		lbl->widget.height_min = cpt_height + 4;
+		lbl->widget.width_ideal = lbl->widget.width_min;
+		lbl->widget.height_ideal = lbl->widget.height_min;
+
+		window_refresh(lbl->widget.window);
+	}
+}
+
+void deinit_label(label_t *lbl)
+{
+	widget_deinit(&lbl->widget);
+	free(lbl->caption);
+	font_release(&lbl->font);
+}
+
+static void label_destroy(widget_t *widget)
+{
+	label_t *lbl = (label_t *) widget;
+
+	deinit_label(lbl);
+	
+	free(lbl);
+}
+
+static void label_reconfigure(widget_t *widget)
+{
+	/* no-op */
+}
+
+static void label_rearrange(widget_t *widget, sysarg_t hpos, sysarg_t vpos,
+    sysarg_t width, sysarg_t height)
+{
+	widget_modify(widget, hpos, vpos, width, height);
+	paint_internal(widget);
+}
+
+static void label_repaint(widget_t *widget)
+{
+	paint_internal(widget);
+	window_damage(widget->window);
+}
+
+static void label_handle_keyboard_event(widget_t *widget, kbd_event_t event)
+{
+	/* no-op */
+}
+
+static void label_handle_position_event(widget_t *widget, pos_event_t event)
+{
+	/* no-op */
+}
+
+bool init_label(label_t *lbl, widget_t *parent,
+    const char *caption, uint16_t points, pixel_t background, pixel_t foreground)
+{
+	widget_init(&lbl->widget, parent);
+
+	lbl->widget.destroy = label_destroy;
+	lbl->widget.reconfigure = label_reconfigure;
+	lbl->widget.rearrange = label_rearrange;
+	lbl->widget.repaint = label_repaint;
+	lbl->widget.handle_keyboard_event = label_handle_keyboard_event;
+	lbl->widget.handle_position_event = label_handle_position_event;
+
+	source_init(&lbl->background);
+	source_set_color(&lbl->background, background);
+	source_init(&lbl->foreground);
+	source_set_color(&lbl->foreground, foreground);
+
+	if (caption == NULL) {
+		lbl->caption = NULL;
+	} else {
+		lbl->caption = str_dup(caption);
+	}
+	font_init(&lbl->font, FONT_DECODER_EMBEDDED, NULL, points);
+
+	sysarg_t cpt_width;
+	sysarg_t cpt_height;
+	font_get_box(&lbl->font, lbl->caption, &cpt_width, &cpt_height);
+	lbl->widget.width_min = cpt_width + 4;
+	lbl->widget.height_min = cpt_height + 4;
+	lbl->widget.width_ideal = lbl->widget.width_min;
+	lbl->widget.height_ideal = lbl->widget.height_min;
+
+	lbl->rewrite = on_rewrite;
+
+	return true;
+}
+
+label_t *create_label(widget_t *parent,
+    const char *caption, uint16_t points, pixel_t background, pixel_t foreground)
+{
+	label_t *lbl = (label_t *) malloc(sizeof(label_t));
+	if (!lbl) {
+		return NULL;
+	}
+
+	if (init_label(lbl, parent, caption, points, background, foreground)) {
+		return lbl;
+	} else {
+		free(lbl);
+		return NULL;
+	}
+}
+
+/** @}
+ */
+
Index: uspace/lib/gui/label.h
===================================================================
--- uspace/lib/gui/label.h	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
+++ uspace/lib/gui/label.h	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -0,0 +1,64 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup gui
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef GUI_LABEL_H_
+#define GUI_LABEL_H_
+
+#include <sys/types.h>
+#include <io/pixel.h>
+
+#include <source.h>
+#include <font.h>
+
+#include "connection.h"
+#include "widget.h"
+
+typedef struct label {
+	widget_t widget;
+	source_t background;
+	source_t foreground;
+	char *caption;
+	font_t font;
+	slot_t rewrite;
+} label_t;
+
+extern bool init_label(label_t *, widget_t *, const char *, uint16_t, pixel_t, pixel_t);
+extern label_t *create_label(widget_t *, const char *, uint16_t, pixel_t, pixel_t);
+extern void deinit_label(label_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/gui/minimal.c
===================================================================
--- uspace/lib/gui/minimal.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
+++ uspace/lib/gui/minimal.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -0,0 +1,147 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup gui
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <malloc.h>
+#include <surface.h>
+
+#include "window.h"
+#include "minimal.h"
+
+static void paint_internal(widget_t *w)
+{
+	minimal_t *min = (minimal_t *) w;
+
+	surface_t *surface = window_claim(min->widget.window);
+	if (!surface) {
+		window_yield(min->widget.window);
+	}
+
+	for (sysarg_t y = w->vpos; y <  w->vpos + w->height; ++y) {
+		for (sysarg_t x = w->hpos; x < w->hpos + w->width; ++x) {
+			if (y % 2) {
+				if (x % 2) {
+					surface_put_pixel(surface, x, y, min->pix_a);
+				} else {
+					surface_put_pixel(surface, x, y, min->pix_b);
+				}
+			} else {
+				if (x % 2) {
+					surface_put_pixel(surface, x, y, min->pix_b);
+				} else {
+					surface_put_pixel(surface, x, y, min->pix_a);
+				}
+			}
+		}
+	}
+	
+	window_yield(min->widget.window);
+}
+
+void deinit_minimal(minimal_t *min)
+{
+	widget_deinit(&min->widget);
+}
+
+static void minimal_destroy(widget_t *widget)
+{
+	minimal_t *min = (minimal_t *) widget;
+
+	deinit_minimal(min);
+
+	free(min);
+}
+
+static void minimal_reconfigure(widget_t *widget)
+{
+	/* no-op */
+}
+
+static void minimal_rearrange(widget_t *widget, sysarg_t hpos, sysarg_t vpos,
+    sysarg_t width, sysarg_t height)
+{
+	widget_modify(widget, hpos, vpos, width, height);
+	paint_internal(widget);
+}
+
+static void minimal_repaint(widget_t *widget)
+{
+	paint_internal(widget);
+	window_damage(widget->window);
+}
+
+static void minimal_handle_keyboard_event(widget_t *widget, kbd_event_t event)
+{
+	/* no-op */
+}
+
+static void minimal_handle_position_event(widget_t *widget, pos_event_t event)
+{
+	/* no-op */
+}
+
+bool init_minimal(minimal_t *min, widget_t *parent, pixel_t a, pixel_t b)
+{
+	widget_init(&min->widget, parent);
+
+	min->widget.destroy = minimal_destroy;
+	min->widget.reconfigure = minimal_reconfigure;
+	min->widget.rearrange = minimal_rearrange;
+	min->widget.repaint = minimal_repaint;
+	min->widget.handle_keyboard_event = minimal_handle_keyboard_event;
+	min->widget.handle_position_event = minimal_handle_position_event;
+
+	min->pix_a = a;
+	min->pix_b = b;
+
+	return true;
+}
+
+minimal_t *create_minimal(widget_t *parent, pixel_t a, pixel_t b)
+{
+	minimal_t *min = (minimal_t *) malloc(sizeof(minimal_t));
+	if (!min) {
+		return NULL;
+	}
+
+	if (init_minimal(min, parent, a, b)) {
+		return min;
+	} else {
+		free(min);
+		return NULL;
+	}
+}
+
+/** @}
+ */
Index: uspace/lib/gui/minimal.h
===================================================================
--- uspace/lib/gui/minimal.h	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
+++ uspace/lib/gui/minimal.h	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -0,0 +1,59 @@
+/*
+ * Copyright (c) 2012 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup gui
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef GUI_MINIMAL_H_
+#define GUI_MINIMAL_H_
+
+#include <bool.h>
+#include <sys/types.h>
+#include <io/pixel.h>
+
+#include "widget.h"
+
+typedef struct minimal {
+	widget_t widget;
+	pixel_t pix_a;
+	pixel_t pix_b;
+} minimal_t;
+
+extern bool init_minimal(minimal_t *, widget_t *, pixel_t, pixel_t);
+extern minimal_t *create_minimal(widget_t *, pixel_t, pixel_t);
+extern void deinit_minimal(minimal_t *);
+
+#endif
+
+/** @}
+ */
+
